//***************************************************************************
//* Copyright (c) 2019 Saint Petersburg State University
//* All Rights Reserved
//* See file LICENSE for details.
//***************************************************************************

#pragma once

#include "modules/alignment/pacbio/config.hpp"

namespace sensitive_aligner {

struct GAlignerConfig {
    // general
    int K = -1;
    std::string path_to_graphfile = "";
    std::string path_to_sequences = "";
    alignment::BWAIndex::AlignmentMode data_type = alignment::BWAIndex::AlignmentMode::Default; // pacbio, nanopore, 16S
    std::string output_file = "";
    std::string output_fasta = "";
    std::string output_proteinfasta = "";
    bool restore_ends = true;

    //path construction
    debruijn_graph::config::pacbio_processor pb;
    HitExtensionConfig hit_extension_cfg;

    GAlignerConfig(const debruijn_graph::config::pacbio_processor &pb_,
                   const alignment::BWAIndex::AlignmentMode &data_type_,
                   const GapClosingConfig &gap_cfg_ = GapClosingConfig(),
                   const EndsClosingConfig &ends_cfg_ = EndsClosingConfig(),
                   const ProteinAlignmentConfig &protein_cfg_ = ProteinAlignmentConfig())
    :data_type(data_type_),
     pb(pb_),
     hit_extension_cfg(gap_cfg_, ends_cfg_, protein_cfg_)
    {}

    GAlignerConfig(){}
};

} // namespace sensitive_aligner